local mapMod = foundation.createMod();

mapMod:registerAssetId("maps/heightmap_riverhold.png", "HEIGHT_MAP")
mapMod:registerAssetId("maps/material_mask_riverhold.png", "MATERIAL_MASK")
mapMod:registerAssetId("maps/deciduous_riverhold.png", "DECIDUOUS_DENSITY_MAP")
mapMod:registerAssetId("maps/intermediate_riverhold.png", "INTERMEDIATE_DENSITY_MAP")

-- Register Custom Map
mapMod:register({
	DataType = "CUSTOM_MAP",
	Id = "MAP_RIVERHOLD_01",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = -7,
	MaxHeight = 81.375,
	VillagePathList = {
		{
			Entrance = { 1020, 0, 588 },
			Exit = { 560, 0, 1020 }
		},
		{
			Entrance = { 116, 0, 4 },
			Exit = { 635, 0, 4 }
		},
		{
			Entrance = { 1020, 0, 93 },
			Exit = { 116, 0, 4 }
		},
		{
			Entrance = { 1020, 0, 758 },
			Exit = { 361, 0, 1020 }
		}					
	},
	SpawnList = {
		-- First spawnpoint
		{
			Prefab = "PREFAB_RESOURCE_BERRIES",
			Position = { 167, 0, 346 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_ROCK",
			Position = { 153, 0, 343 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		
		-- Second spawnpoint
		{
			Prefab = "PREFAB_RESOURCE_ROCK",
			Position = { 191, 0, 637 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_BERRIES",
			Position = { 233, 0, 638 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},		
		
		-- Third spawnpoint
		{
			Prefab = "PREFAB_RESOURCE_BERRIES",
			Position = { 619, 0, 624 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_ROCK",
			Position = { 571, 0, 654 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_BERRIES",
			Position = { 618, 0, 630 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
				
		-- Fourth spawnpoint
		{
			Prefab = "PREFAB_RESOURCE_BERRIES",
			Position = { 626, 0, 234 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_ROCK",
			Position = { 627, 0, 249 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_ROCK",
			Position = { 634, 0, 260 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		-- Other resources
		-- Berries
		{
			Prefab = "PREFAB_RESOURCE_BERRIES",
			Position = { 342, 0, 277 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_BERRIES",
			Position = { 307, 0, 474 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_BERRIES",
			Position = { 418, 0, 464 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_BERRIES",
			Position = { 428, 0, 461 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_BERRIES",
			Position = { 555, 0, 442 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_BERRIES",
			Position = { 720, 0, 413 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},		
		{
			Prefab = "PREFAB_RESOURCE_BERRIES",
			Position = { 882, 0, 362 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_BERRIES",
			Position = { 1006, 0, 254 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_BERRIES",
			Position = { 989, 0, 328 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_BERRIES",
			Position = { 198, 0, 223 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_BERRIES",
			Position = { 449, 0, 780 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_BERRIES",
			Position = { 96, 0, 790 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_BERRIES",
			Position = { 649, 0, 383 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_BERRIES",
			Position = { 826, 0, 286 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_BERRIES",
			Position = { 834, 0, 498 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_BERRIES",
			Position = { 850, 0, 958 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_BERRIES",
			Position = { 843, 0, 960 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		--Rock		
		{
			Prefab = "PREFAB_RESOURCE_ROCK",
			Position = { 443, 0, 391 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_ROCK",
			Position = { 863, 0, 158 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_ROCK",
			Position = { 874, 0, 612 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_ROCK",
			Position = { 436, 0, 938 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_ROCK",
			Position = { 372, 0, 624 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_ROCK",
			Position = { 721, 0, 472 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_ROCK",
			Position = { 800, 0, 830 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_ROCK",
			Position = { 808, 0, 840 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_ROCK",
			Position = { 594, 0, 70 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_ROCK",
			Position = { 322, 0, 154 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		-- Minerals		
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 380, 31.6, 113 },
			Orientation = { 0.0, math.randomf(220, 240), 0.0 },
			PatchBeforeVersion = "1.0.1"
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 297, 32.2, 274 },
			Orientation = { 0.0, math.randomf(260, 280), 0.0 },	
			PatchBeforeVersion = "1.0.1"	
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 297, 32.8, 262 },
			Orientation = { 0.0, math.randomf(240, 270), 0.0 },
			PatchBeforeVersion = "1.0.1"				
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 154, 25.9, 810 },
			Orientation = { 0.0, math.randomf(180, 235), 0.0 },
			PatchBeforeVersion = "1.0.1"	
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 428, 31.8, 741 },
			Orientation = { 0.0, math.randomf(160, 190), 0.0 },	
			PatchBeforeVersion = "1.0.1"	
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 483, 31.8, 699 },
			Orientation = { 0.0, math.randomf(-90, 0), 0.0 },
			PatchBeforeVersion = "1.0.1"	
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 572, 47.8, 317 },
			Orientation = { 0.0, math.randomf(-30, -5), 0.0 },
			PatchBeforeVersion = "1.0.1"	
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 652, 41.5, 297 },
			Orientation = { 0.0, math.randomf(70, 90), 0.0 },
			PatchBeforeVersion = "1.0.1"	
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 654, 40.8, 309 },
			Orientation = { 0.0, math.randomf(100, 120), 0.0 },	
			PatchBeforeVersion = "1.0.1"	
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 828, 37.3, 561 },
			Orientation = { 0.0, math.randomf(230, 280), 0.0 },
			PatchBeforeVersion = "1.0.1"	
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 663, 56.2, 930 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }		
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 923, 60.7, 908 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }		
		},
		
		-- Fish
		{
			Prefab = "PREFAB_RESOURCE_FISH",
			Position = { 47, 0, 999 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_FISH",
			Position = { 24, 0, 984 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_FISH",
			Position = { 38, 0, 956 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_FISH",
			Position = { 23, 0, 914 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_FISH",
			Position = { 31, 0, 871 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_FISH",
			Position = { 186, 0, 536 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_FISH",
			Position = { 207, 0, 559 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_FISH",
			Position = { 164, 0, 586 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_FISH",
			Position = { 111, 0, 567 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_FISH",
			Position = { 66, 0, 634 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_FISH",
			Position = { 26, 0, 383 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_FISH",
			Position = { 26, 0, 482 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_FISH",
			Position = { 277, 0, 528 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_FISH",
			Position = { 846, 0, 390 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_FISH",
			Position = { 817, 0, 394 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_FISH",
			Position = { 793, 0, 400 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_FISH",
			Position = { 20, 0, 583 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		}		
	},
	DensitySpawnList = {
		{
			-- Create forest of Deciduous trees and a few smaller Pine trees
			DensityMap = "INTERMEDIATE_DENSITY_MAP",
			Density = 0.9,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_SYCAMORE", "PREFAB_TREE_OAK", "PREFAB_TREE_POPLAR" },
					RandomWeight = 0.75,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.7, 0.7, 0.7, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 0.25,
					OffsetSizeRange = {
						Min = 0.45,
						Max = 0.75
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.75,
						Max = 1.05
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},		
		{
			-- Create forest of Deciduous trees
			DensityMap = "DECIDUOUS_DENSITY_MAP",
			Density = 0.9,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_SYCAMORE", "PREFAB_TREE_OAK", "PREFAB_TREE_POPLAR" },
					RandomWeight = 1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1.15
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		}
	}
})